%ext ck2
%version 1.31

#%dump DCLEAN.DMP

#############################
#BEFORE STARTING ACTUAL GAME#
#############################

#Loading Screen
%patch $19A0B "Loading Commander Keen & The Mortrix...                "

#Loading tile info
%patchfile 0x17828 tiles.tli

#Loading text files
%patchfile $15BC0 "HELPTXT.CK2" #Change the help text, max file length 2'016 bytes
%patchfile $16AC0 "STORYTXT.CK2" #Change the story, max file length 3'232 bytes
%patchfile $163A0 "PREVIEWS.CK2" #Change the previews, max file length 1'824 bytes
%patchfile $15844 ENDTEXT.CK2 #Patch endtext (Max length 896 bytes)

###################
#MENU AND SECTIONS#
###################

#The title bitmap will be shown at offset 0,0
%patch $9233   $00 $00     # Y location, in pixels
%patch $9237   $04 $00     # (X location in pixels) / 8 + 4 

#Menu
%patch $1A6C9 "Load Game    "
%patch $1A6E5 "About Me..."
%patch $1A705 "Quillax Ship "
%patch $1A717 "More Mods"

#About ID
%patch $1A754 "Hi! I'm Quillax (AKA Q-Nova), and "
%patch $1A77C "I love games such as Commander   "
%patch $1A7A4 "Keen and Mario, so my stuff is"
%patch $1A7CC "usually about them. "
%patch $1A7F4 "I've been making Keen mods and  "
%patch $1A81C "fangames since the early 2010s! The"
%patch $1A844 "first Keen games I played "
%patch $1A86C "are episodes 4 and 6.  "
%patch $1A894 "I have a site known as the   "
%patch $1A8BC "Quillax Ship. It has downloads   "
%patch $1A8E4 "for my mods and fangames."

#Default high score entries
%patch $7D4D $2D57W #Block location
%patch $7D51 $002DW #Block length
%patch $7E41 $0007W #Number of names
%patch $7E47 $0006W #Name length

#Default highscore names
#NOTE: Scrub is named Suerin
%patch $1A4D7 "Keen " $00
              "Nisab" $00
              "Gigab" $00
              "Tacky" $00
              "Malti" $00
              "Sprug" $00
              "Sueri" $00

#Ordering Info
%patch $1AADA "The Quillax Ship is a website that  "
%patch $1AB00 "hosts Commander Keen mods and Mario "
%patch $1AB26 "fangames made by me, Quillax.  "
%patch $1AB48 "Within the site includes:          "
%patch $1AB6D "*This mod       *The Sunnylands    "
%patch $1AB92 "*The Morticore  *QNKL              "
%patch $1ABB7 "*ROM Trilogy    *Go! Go! Gooble!!"
%patch $1ABDA "*And more!                 "
%patch $1ABF8 "                         "
%patch $1AC13 "                         "
%patch $1AC2E "                         "
%patch $1AC49 "                           "
%patch $1AC67 "To visit the Quillax Ship, go to: "
%patch $1AC8B "quillaxship.com                 "
%patch $1ACAD "I hope you'll have fun with what it "
%patch $1ACD3 "has and look forward to more stuff! "

############
#GAME START#
############

#Shots Keen has at game start
%patch $8AA2  $0005W

#Keens Left text
%patch $1A6AE "Lives Left"

###############
#STATUS SCREEN#
###############

#Status Screen
%patch $1992A "EXTRA LIFE AT"
%patch $19941 "LIVES"
%patch $19952 "N.STUN"
%patch $19967 "ITEMS SAVED  "
%patch $199AB "N.Stun"
%patch $199B2 "BwB  "
%patch $199B8 "AoR   "
%patch $199BF "C.Wrist "
%patch $199C8 "PT   "
%patch $199CE "Pogo"
%patch $199D3 "L.1000"
%patch $199DA "Spot     "

########
#CHEATS#
########

#CTSpace textbpx:
%patch $0DC8 $01 $00 #Height [In lines of text]
%patch $0DCC $0C $00 #Width [in letters]

#CTSpace text:
%patch $198C6 "Free items!" $00
%patch $198DD $00
%patch $198F3 $00
%patch $1990B $00

#God cheat textbox:
%patch $11E2 $0D $00 #Width [in letters]

#God mode cheat text:
%patch $199E4 "God mode ON" $00
%patch $199F5 "God mode OFF" $00

########
#ACTORS#
########

###############
#YOUTH (SPRUG)#
###############

#Probability of Youth jumping (max so it's bouncing almost all the time)
%patch $4001 $FF

#Youth speeds
#Initial speeds
%patch $3CA4 $007DW #If left of Keen (Move right)
%patch $3C9D $FF83W #If right of Keen (Move left)

#When walking\jumping
%patch $4047 $007DW #Hits left wall (Go right)
%patch $403B $FF83W #Hits right wall (Go left)

#When falling\sliding
%patch $408E $007DW #Hits left wall (Go right)
%patch $4082 $FF83W #Hits right wall (Go left)

#####################
#VORTICON (MALTIMER)#
#####################

#Vorticon (virus)
#When walking about randomly:
%patch $3EC9 $005AW      #Bounce off right walls
%patch $3ED5 $FFA6W      #Bounce off left walls

#Speed swapping while walking:
%patch $3E81 $FFA6W  $74 #If speed is this...
%patch $3EAE $005AW      #Set it to this
%patch $3E88 $005AW  $74 #If speed  is this...
%patch $3EA6 $FFA6W      #Set it to this
%patch $3E8D $FFA6W  $74 #If speed is this...
%patch $3E9E $005AW      #Set it to this
%patch $3E94 $005AW  $74 #If speed is this...
%patch $3EB6 $FFA6W      #Set it to this

#When jumping, falling or sliding across the ground:
%patch $3F22 $005AW #Bounce off right walls
%patch $3F2E $FFA6W #Bounce off left walls

#Vorticon death sound (Garg death)
%patch $3FA7 $23

########################
#VORTICON ELITE (TACKY)#
########################

#When walking\jumping
%patch $4150 $0064W #Charging speed l/r (If Keen is level with Elite)

#Elite pushes Keen and its shots are not affected by it
%patch $3CB9 $05
%patch $7775 $3D $05

########################
#GUARD ROBOT (GIGABITE)#
########################

#Guard robot doesn't shoot nor make sounds (done by making pause before shooting longer than total time)
%patch $45E8  $0026W #Pause before shooting
%patch $45F0  $0025W #Total time

#Guard robot speeds
%patch $3D7B $0096W #Move right (spawn)
%patch $458B $0096W #Hits left wall (Go right)
%patch $45A5 $FF6AW #Hits right wall (Go left)

#This one seems to change the rate of guard robot shooting
#Keeping it just in case
#%patch $4605 $23

#########################
#VORTICON ELDER (NISABA)#
#########################

#Hint level 8 (unused)
#%patch $19FCC "Nisaba says:          "
#%patch $19FE4 "Hey there Keen, still "
#%patch $19FFC "awesome meeting you.  "
#%patch $1A014 "While sneaking around,"
#%patch $1A02C "I noticed that some   "
#%patch $1A044 "spots are pass-through"
#%patch $1A05C "even if they do not   "
#%patch $1A074 "seem so. Weird!       "

#Hint level 8
%patch $19FCC "Nisaba says:          "
%patch $19FE4 "Hey there Keen, still "
%patch $19FFC "awesome meeting you.  "
%patch $1A014 "I noticed that viruses"
%patch $1A02C "and antiviruses don't "
%patch $1A044 "jump whenever it seems"
%patch $1A05C "dark. Oh, and avoid   "
%patch $1A074 "any words from tacks! "

#Hint level 10
%patch $1A08C "Nisaba says:          "
%patch $1A0A4 "Oh thank you so much  "
%patch $1A0BC "for rescuing me! I did"
%patch $1A0D4 "not expect the cans to"
%patch $1A0EC "treat me like that! So"
%patch $1A104 "many things seem to   "
%patch $1A11C "trick our eyes. I     "
%patch $1A134 "mean, there are pass- "
%patch $1A14C "through spots that do "
%patch $1A164 "not seem so, like the "
%patch $1A17C "block in front of me! "

############
#TELEPORTER#
############

#Teleporter wins level
%patch $736C $0001W

##########################
#TANTALUS MACHINE AND RAY#
##########################

#Replacement tiles for tantalus dome destruction:
%patch $48D2 $0092W #Top middle
%patch $4905 $008FW #Bottom left
%patch $4934 $008FW #Bottom right

#Replacement tile after Earth explodes
%patch $4D2E $01C6W

#########################
#TANTALUS MACHINE SWITCH#
#########################

#What makes a switch a 'End the world' switch:
%patch $6443 $4C $02 #Tile needed
%patch $6437 $05     #Number of tiles right of switch tile needs to be

#Text
%patch $1A470 "Yes!!"

#Flipping the 'End of world' switch wins the level
%patch $64F9 $0001W

#This makes the game continue after the 'Oops.' box, as if nothing ever happened
#%patch $64F6 $0001W
#This removes the 'Oops.' box
#%patch $64F1 $0001W
#This seems to change the width of the 'Oops.' box
#%patch $64DA $0001W

########
#ENDING#
########

#Finale
%patch $1A1A1 "Keen did it! All 8 Mortrix app-"
%patch $1A1C2 "lications are shut down! Keen "
%patch $1A1E2 "ran out and did a radical,  "
%patch $1A200 "near-impossible pogo trick   "
%patch $1A21F "over the now-disabled    "
%patch $1A23A "Anti-Virus Abolisher!   "

%patch $1A253 "After hitting the 'CLEAR    "
%patch $1A271 "VIRUSES' button, the Virus   "
%patch $1A292 "Vacuum released the toughest"
%patch $1A2B0 "of the Tackys! Meanwhile, "
%patch $1A2CC "a beam takes Keen as he flies."

%patch $1A2F7 "Soon, Keen felt    "
%patch $1A30C "like he was warped"
%patch $1A320 "back to reality!  "

%patch $1A333 "Well, it seems that he  "
%patch $1A34D "got a bit dizzy from the"
%patch $1A367 "transportation..."
%patch $1A37A "But hey, the Doscom"
%patch $1A38F "is now all back to    "
%patch $1A3A7 "normal! The Mortrix "
%patch $1A3BD "is gone!  "

%patch $1A3C9 "Keen felt, though,"
%patch $1A3DD "that he should prepare  "
%patch $1A3F7 "himself for any bad   "
%patch $1A40F "stuff that may happen..."

%patch $1A429 "Riiiiight?"

%patch $1A434 "The End....for now."

###########
#GAME OVER#
###########

#'You saved X cities!' text
%patch $1A659 " items! " $00
%patch $1A662 " item!" $00
%patch $1A64E "no items! " $00

#%dump DMOD.DMP

%end